Package com.google.android.exoplayer2.source

## Class MergingMediaSource

- java.lang.Object
- - com.google.android.exoplayer2.source.BaseMediaSource
  - - com.google.android.exoplayer2.source.CompositeMediaSource<Integer>
    - - com.google.android.exoplayer2.source.MergingMediaSource

- All Implemented Interfaces:
    `MediaSource`

      public final class MergingMediaSource
      extends CompositeMediaSource<Integer>

  Merges multiple `MediaSource`s.

  The `Timeline`s of the sources being merged must have the same number of periods.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `MergingMediaSource.IllegalMergeException` | Thrown when a `MergingMediaSource` cannot merge its sources.

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.source.MediaSource

      `MediaSource.Factory, MediaSource.MediaPeriodId, MediaSource.MediaSourceCaller`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MergingMediaSource​(boolean adjustPeriodTimeOffsets, boolean clipDurations, CompositeSequenceableLoaderFactory compositeSequenceableLoaderFactory, MediaSource... mediaSources)` | Creates a merging media source.
    `MergingMediaSource​(boolean adjustPeriodTimeOffsets, boolean clipDurations, MediaSource... mediaSources)` | Creates a merging media source.
    `MergingMediaSource​(boolean adjustPeriodTimeOffsets, MediaSource... mediaSources)` | Creates a merging media source.
    `MergingMediaSource​(MediaSource... mediaSources)` | Creates a merging media source.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `MediaPeriod` | `createPeriod​(MediaSource.MediaPeriodId id, Allocator allocator, long startPositionUs)` | Returns a new `MediaPeriod` identified by `periodId`.
    `MediaItem` | `getMediaItem()` | Returns the `MediaItem` whose media is provided by the source.
    `protected MediaSource.MediaPeriodId` | `getMediaPeriodIdForChildMediaPeriodId​(Integer childSourceId, MediaSource.MediaPeriodId mediaPeriodId)` | Returns the `MediaSource.MediaPeriodId` in the composite source corresponding to the specified `MediaSource.MediaPeriodId` in a child source.
    `void` | `maybeThrowSourceInfoRefreshError()` | Throws any pending error encountered while loading or refreshing source information.
    `protected void` | `onChildSourceInfoRefreshed​(Integer childSourceId, MediaSource mediaSource, Timeline newTimeline)` | Called when the source info of a child source has been refreshed.
    `protected void` | `prepareSourceInternal​(TransferListener mediaTransferListener)` | Starts source preparation and enables the source, see `BaseMediaSource.prepareSource(MediaSourceCaller, TransferListener, PlayerId)`.
    `void` | `releasePeriod​(MediaPeriod mediaPeriod)` | Releases the period.
    `protected void` | `releaseSourceInternal()` | Releases the source, see `BaseMediaSource.releaseSource(MediaSourceCaller)`.

    - ### Methods inherited from class com.google.android.exoplayer2.source.CompositeMediaSource

      `disableChildSource, disableInternal, enableChildSource, enableInternal, getMediaTimeForChildMediaTime, getWindowIndexForChildWindowIndex, prepareChildSource, releaseChildSource`

    - ### Methods inherited from class com.google.android.exoplayer2.source.BaseMediaSource

      `addDrmEventListener, addEventListener, createDrmEventDispatcher, createDrmEventDispatcher, createEventDispatcher, createEventDispatcher, createEventDispatcher, disable, enable, getPlayerId, isEnabled, prepareSource, prepareSource, refreshSourceInfo, releaseSource, removeDrmEventListener, removeEventListener`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.android.exoplayer2.source.MediaSource

      `getInitialTimeline, isSingleWindow`

- - ### Constructor Detail

    - #### MergingMediaSource

          public MergingMediaSource​(MediaSource... mediaSources)

      Creates a merging media source.

      Neither offsets between the timestamps in the media sources nor the durations of the media sources will be adjusted.

      Parameters:
        `mediaSources` - The `MediaSources` to merge.

    - #### MergingMediaSource

          public MergingMediaSource​(boolean adjustPeriodTimeOffsets,
                                    MediaSource... mediaSources)

      Creates a merging media source.

      Durations of the media sources will not be adjusted.

      Parameters:
        `adjustPeriodTimeOffsets` - Whether to adjust timestamps of the merged media sources to all start at the same time.
        `mediaSources` - The `MediaSources` to merge.

    - #### MergingMediaSource

          public MergingMediaSource​(boolean adjustPeriodTimeOffsets,
                                    boolean clipDurations,
                                    MediaSource... mediaSources)

      Creates a merging media source.
      Parameters:
        `adjustPeriodTimeOffsets` - Whether to adjust timestamps of the merged media sources to all start at the same time.
        `clipDurations` - Whether to clip the durations of the media sources to match the shortest duration.
        `mediaSources` - The `MediaSources` to merge.

    - #### MergingMediaSource

          public MergingMediaSource​(boolean adjustPeriodTimeOffsets,
                                    boolean clipDurations,
                                    CompositeSequenceableLoaderFactory compositeSequenceableLoaderFactory,
                                    MediaSource... mediaSources)

      Creates a merging media source.
      Parameters:
        `adjustPeriodTimeOffsets` - Whether to adjust timestamps of the merged media sources to all start at the same time.
        `clipDurations` - Whether to clip the durations of the media sources to match the shortest duration.
        `compositeSequenceableLoaderFactory` - A factory to create composite `SequenceableLoader`s for when this media source loads data from multiple streams (video, audio etc...).
        `mediaSources` - The `MediaSources` to merge.

  - ### Method Detail

    - #### getMediaItem

          public MediaItem getMediaItem()

      Description copied from interface: `MediaSource`
      Returns the `MediaItem` whose media is provided by the source.

    - #### prepareSourceInternal

          protected void prepareSourceInternal​(@Nullable
                                               TransferListener mediaTransferListener)

      Description copied from class: `BaseMediaSource`
      Starts source preparation and enables the source, see `BaseMediaSource.prepareSource(MediaSourceCaller, TransferListener, PlayerId)`. This method is called at most once until the next call to `BaseMediaSource.releaseSourceInternal()`.
      Overrides:
        `prepareSourceInternal` in class `CompositeMediaSource<Integer>`
      Parameters:
        `mediaTransferListener` - The transfer listener which should be informed of any media data transfers. May be null if no listener is available. Note that this listener should usually be only informed of transfers related to the media loads and not of auxiliary loads for manifests and other data.

    - #### maybeThrowSourceInfoRefreshError

          public void maybeThrowSourceInfoRefreshError()
                                                throws IOException

      Description copied from interface: `MediaSource`
      Throws any pending error encountered while loading or refreshing source information.

      Should not be called directly from application code.

      Must only be called after `MediaSource.prepareSource(MediaSourceCaller, TransferListener, PlayerId)`.

      Specified by:
        `maybeThrowSourceInfoRefreshError` in interface `MediaSource`
      Overrides:
        `maybeThrowSourceInfoRefreshError` in class `CompositeMediaSource<Integer>`
      Throws:
        `IOException`

    - #### createPeriod

          public MediaPeriod createPeriod​(MediaSource.MediaPeriodId id,
                                          Allocator allocator,
                                          long startPositionUs)

      Description copied from interface: `MediaSource`
      Returns a new `MediaPeriod` identified by `periodId`.

      Should not be called directly from application code.

      Must only be called if the source is enabled.

      Parameters:
        `id` - The identifier of the period.
        `allocator` - An `Allocator` from which to obtain media buffer allocations.
        `startPositionUs` - The expected start position, in microseconds.
      Returns:
        A new `MediaPeriod`.

    - #### releasePeriod

          public void releasePeriod​(MediaPeriod mediaPeriod)

      Description copied from interface: `MediaSource`
      Releases the period.

      Should not be called directly from application code.

      Parameters:
        `mediaPeriod` - The period to release.

    - #### releaseSourceInternal

          protected void releaseSourceInternal()

      Description copied from class: `BaseMediaSource`
      Releases the source, see `BaseMediaSource.releaseSource(MediaSourceCaller)`. This method is called exactly once after each call to `BaseMediaSource.prepareSourceInternal(TransferListener)`.
      Overrides:
        `releaseSourceInternal` in class `CompositeMediaSource<Integer>`

    - #### onChildSourceInfoRefreshed

          protected void onChildSourceInfoRefreshed​(Integer childSourceId,
                                                    MediaSource mediaSource,
                                                    Timeline newTimeline)

      Description copied from class: `CompositeMediaSource`
      Called when the source info of a child source has been refreshed.
      Specified by:
        `onChildSourceInfoRefreshed` in class `CompositeMediaSource<Integer>`
      Parameters:
        `childSourceId` - The unique id used to prepare the child source.
        `mediaSource` - The child source whose source info has been refreshed.
        `newTimeline` - The timeline of the child source.

    - #### getMediaPeriodIdForChildMediaPeriodId

          @Nullable
          protected MediaSource.MediaPeriodId getMediaPeriodIdForChildMediaPeriodId​(Integer childSourceId,
                                                                                    MediaSource.MediaPeriodId mediaPeriodId)

      Description copied from class: `CompositeMediaSource`
      Returns the `MediaSource.MediaPeriodId` in the composite source corresponding to the specified `MediaSource.MediaPeriodId` in a child source. The default implementation does not change the media period id.
      Overrides:
        `getMediaPeriodIdForChildMediaPeriodId` in class `CompositeMediaSource<Integer>`
      Parameters:
        `childSourceId` - The unique id used to prepare the child source.
        `mediaPeriodId` - A `MediaSource.MediaPeriodId` of the child source.
      Returns:
        The corresponding `MediaSource.MediaPeriodId` in the composite source. Null if no corresponding media period id can be determined.